Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.bidimap
Class AbstractDualBidiMap

    java.lang.Object
      org.apache.commons.collections.bidimap.AbstractDualBidiMap

All Implemented Interfaces:
  java.util.Map, BidiMap, IterableMap

Direct Known Subclasses:
  DualHashBidiMap, DualTreeBidiMap

    public abstract class AbstractDualBidiMap

extends java.lang.Object
implements BidiMap

Abstract `BidiMap` implemented using two maps.

An implementation can be written simply by implementing the `createMap` method.

Since:
  Commons Collections 3.0
Version:
  $Id: AbstractDualBidiMap.java 646777 2008-04-10 12:33:15Z niallp $
Author:
  Matthew Hawthorne, Stephen Colebourne
See Also:
  `DualHashBidiMap`, `DualTreeBidiMap`

Nested Class Summary
`protected static class` | `AbstractDualBidiMap.BidiMapIterator` Inner class MapIterator.
`protected static class` | `AbstractDualBidiMap.EntrySet` Inner class EntrySet.
`protected static class` | `AbstractDualBidiMap.EntrySetIterator` Inner class EntrySetIterator.
`protected static class` | `AbstractDualBidiMap.KeySet` Inner class KeySet.
`protected static class` | `AbstractDualBidiMap.KeySetIterator` Inner class KeySetIterator.
`protected static class` | `AbstractDualBidiMap.MapEntry` Inner class MapEntry.
`protected static class` | `AbstractDualBidiMap.Values` Inner class Values.
`protected static class` | `AbstractDualBidiMap.ValuesIterator` Inner class ValuesIterator.
`protected static class` | `AbstractDualBidiMap.View` Inner class View.

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary
`protected java.util.Set` | `entrySet` View of the entries.
`protected BidiMap` | `inverseBidiMap` Inverse view of this map.
`protected java.util.Set` | `keySet` View of the keys.
`protected java.util.Map[]` | `maps` Delegate map array.
`protected java.util.Collection` | `values` View of the values.

Constructor Summary
`protected` | `AbstractDualBidiMap()` Creates an empty map, initialised by `createMap`.
`protected` | `AbstractDualBidiMap(java.util.Map normalMap, java.util.Map reverseMap)` Creates an empty map using the two maps specified as storage.
`protected` | `AbstractDualBidiMap(java.util.Map normalMap, java.util.Map reverseMap, BidiMap inverseBidiMap)` Constructs a map that decorates the specified maps, used by the subclass `createBidiMap` implementation.

Method Summary
`void` | `clear()`
`boolean` | `containsKey(java.lang.Object key)`
`boolean` | `containsValue(java.lang.Object value)`
`protected abstract BidiMap` | `createBidiMap(java.util.Map normalMap, java.util.Map reverseMap, BidiMap inverseMap)` Creates a new instance of the subclass.
`protected java.util.Iterator` | `createEntrySetIterator(java.util.Iterator iterator)` Creates an entry set iterator.
`protected java.util.Iterator` | `createKeySetIterator(java.util.Iterator iterator)` Creates a key set iterator.
`protected java.util.Map` | `createMap()` Deprecated. For constructors, use the new two map constructor. For deserialization, populate the maps array directly in readObject.
`protected java.util.Iterator` | `createValuesIterator(java.util.Iterator iterator)` Creates a values iterator.
`java.util.Set` | `entrySet()` Gets an entrySet view of the map.
`boolean` | `equals(java.lang.Object obj)`
`java.lang.Object` | `get(java.lang.Object key)`
`java.lang.Object` | `getKey(java.lang.Object value)` Gets the key that is currently mapped to the specified value.
`int` | `hashCode()`
`BidiMap` | `inverseBidiMap()` Gets a view of this map where the keys and values are reversed.
`boolean` | `isEmpty()`
`java.util.Set` | `keySet()` Gets a keySet view of the map.
`MapIterator` | `mapIterator()` Obtains a `MapIterator` over the map.
`java.lang.Object` | `put(java.lang.Object key, java.lang.Object value)` Puts the key-value pair into the map, replacing any previous pair.
`void` | `putAll(java.util.Map map)`
`java.lang.Object` | `remove(java.lang.Object key)`
`java.lang.Object` | `removeValue(java.lang.Object value)` Removes the key-value pair that is currently mapped to the specified value (optional operation).
`int` | `size()`
`java.lang.String` | `toString()`
`java.util.Collection` | `values()` Gets a values view of the map.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### maps

    protected final transient java.util.Map[] maps

  Delegate map array. The first map contains standard entries, and the second contains inverses.

### inverseBidiMap

    protected transient BidiMap inverseBidiMap

  Inverse view of this map.

### keySet

    protected transient java.util.Set keySet

  View of the keys.

### values

    protected transient java.util.Collection values

  View of the values.

### entrySet

    protected transient java.util.Set entrySet

  View of the entries.

Constructor Detail

### AbstractDualBidiMap

    protected AbstractDualBidiMap()

  Creates an empty map, initialised by `createMap`.

  This constructor remains in place for deserialization. All other usage is deprecated in favour of `AbstractDualBidiMap(Map, Map)`.

### AbstractDualBidiMap

    protected AbstractDualBidiMap(java.util.Map normalMap,
                                  java.util.Map reverseMap)

  Creates an empty map using the two maps specified as storage.

  The two maps must be a matching pair, normal and reverse. They will typically both be empty.

  Neither map is validated, so nulls may be passed in. If you choose to do this then the subclass constructor must populate the `maps[]` instance variable itself.

  Parameters:
    `normalMap` - the normal direction map
    `reverseMap` - the reverse direction map
  Since:
    Commons Collections 3.1

### AbstractDualBidiMap

    protected AbstractDualBidiMap(java.util.Map normalMap,
                                  java.util.Map reverseMap,
                                  BidiMap inverseBidiMap)

  Constructs a map that decorates the specified maps, used by the subclass `createBidiMap` implementation.

  Parameters:
    `normalMap` - the normal direction map
    `reverseMap` - the reverse direction map
    `inverseBidiMap` - the inverse BidiMap

Method Detail

### createMap

    protected java.util.Map createMap()

  Deprecated. For constructors, use the new two map constructor. For deserialization, populate the maps array directly in readObject.

  Creates a new instance of the map used by the subclass to store data.

  This design is deeply flawed and has been deprecated. It relied on subclass data being used during a superclass constructor.

  Returns:
    the map to be used for internal storage

### createBidiMap

    protected abstract BidiMap createBidiMap(java.util.Map normalMap,
                                             java.util.Map reverseMap,
                                             BidiMap inverseMap)

  Creates a new instance of the subclass.

  Parameters:
    `normalMap` - the normal direction map
    `reverseMap` - the reverse direction map
    `inverseMap` - this map, which is the inverse in the new map
  Returns:
    the inverse map

### get

    public java.lang.Object get(java.lang.Object key)

  Specified by:
    `get` in interface `java.util.Map`

### size

    public int size()

  Specified by:
    `size` in interface `java.util.Map`

### isEmpty

    public boolean isEmpty()

  Specified by:
    `isEmpty` in interface `java.util.Map`

### containsKey

    public boolean containsKey(java.lang.Object key)

  Specified by:
    `containsKey` in interface `java.util.Map`

### equals

    public boolean equals(java.lang.Object obj)

  Specified by:
    `equals` in interface `java.util.Map`
  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  Specified by:
    `hashCode` in interface `java.util.Map`
  Overrides:
    `hashCode` in class `java.lang.Object`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### put

    public java.lang.Object put(java.lang.Object key,
                                java.lang.Object value)

  Description copied from interface: `BidiMap`
  Puts the key-value pair into the map, replacing any previous pair.

  When adding a key-value pair, the value may already exist in the map against a different key. That mapping is removed, to ensure that the value only occurs once in the inverse map.

        BidiMap map1 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("A","C");  // contains A mapped to C, as per Map

        BidiMap map2 = new DualHashBidiMap();
        map.put("A","B");  // contains A mapped to B, as per Map
        map.put("C","B");  // contains C mapped to B, key A is removed

  Specified by:
    `put` in interface `java.util.Map`
  Specified by:
    `put` in interface `BidiMap`
  Parameters:
    `key` - the key to store
    `value` - the value to store
  Returns:
    the previous value mapped to this key

### putAll

    public void putAll(java.util.Map map)

  Specified by:
    `putAll` in interface `java.util.Map`

### remove

    public java.lang.Object remove(java.lang.Object key)

  Specified by:
    `remove` in interface `java.util.Map`

### clear

    public void clear()

  Specified by:
    `clear` in interface `java.util.Map`

### containsValue

    public boolean containsValue(java.lang.Object value)

  Specified by:
    `containsValue` in interface `java.util.Map`

### mapIterator

    public MapIterator mapIterator()

  Obtains a `MapIterator` over the map. The iterator implements `ResetableMapIterator`. This implementation relies on the entrySet iterator.

  The setValue() methods only allow a new value to be set. If the value being set is already in the map, an IllegalArgumentException is thrown (as setValue cannot change the size of the map).

  Specified by:
    `mapIterator` in interface `BidiMap`
  Specified by:
    `mapIterator` in interface `IterableMap`
  Returns:
    a map iterator

### getKey

    public java.lang.Object getKey(java.lang.Object value)

  Description copied from interface: `BidiMap`
  Gets the key that is currently mapped to the specified value.

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `get(Object)`.

  Specified by:
    `getKey` in interface `BidiMap`
  Parameters:
    `value` - the value to find the key for
  Returns:
    the mapped key, or `null` if not found

### removeValue

    public java.lang.Object removeValue(java.lang.Object value)

  Description copied from interface: `BidiMap`
  Removes the key-value pair that is currently mapped to the specified value (optional operation).

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `remove(Object)`.

  Specified by:
    `removeValue` in interface `BidiMap`
  Parameters:
    `value` - the value to find the key-value pair for
  Returns:
    the key that was removed, `null` if nothing removed

### inverseBidiMap

    public BidiMap inverseBidiMap()

  Description copied from interface: `BidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Specified by:
    `inverseBidiMap` in interface `BidiMap`
  Returns:
    an inverted bidirectional map

### keySet

    public java.util.Set keySet()

  Gets a keySet view of the map. Changes made on the view are reflected in the map. The set supports remove and clear but not add.

  Specified by:
    `keySet` in interface `java.util.Map`
  Returns:
    the keySet view

### createKeySetIterator

    protected java.util.Iterator createKeySetIterator(java.util.Iterator iterator)

  Creates a key set iterator. Subclasses can override this to return iterators with different properties.

  Parameters:
    `iterator` - the iterator to decorate
  Returns:
    the keySet iterator

### values

    public java.util.Collection values()

  Gets a values view of the map. Changes made on the view are reflected in the map. The set supports remove and clear but not add.

  Specified by:
    `values` in interface `java.util.Map`
  Returns:
    the values view

### createValuesIterator

    protected java.util.Iterator createValuesIterator(java.util.Iterator iterator)

  Creates a values iterator. Subclasses can override this to return iterators with different properties.

  Parameters:
    `iterator` - the iterator to decorate
  Returns:
    the values iterator

### entrySet

    public java.util.Set entrySet()

  Gets an entrySet view of the map. Changes made on the set are reflected in the map. The set supports remove and clear but not add.

  The Map Entry setValue() method only allow a new value to be set. If the value being set is already in the map, an IllegalArgumentException is thrown (as setValue cannot change the size of the map).

  Specified by:
    `entrySet` in interface `java.util.Map`
  Returns:
    the entrySet view

### createEntrySetIterator

    protected java.util.Iterator createEntrySetIterator(java.util.Iterator iterator)

  Creates an entry set iterator. Subclasses can override this to return iterators with different properties.

  Parameters:
    `iterator` - the iterator to decorate
  Returns:
    the entrySet iterator

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.